// $Id$

/*************************************************************************
 * XDAQ Components for Distributed Data Acquisition                      *
 * Copyright (C) 2000-2004, CERN.			                 *
 * All rights reserved.                                                  *
 * Authors: J. Gutleber and L. Orsini					 *
 *                                                                       *
 * For the licensing terms see LICENSE.		                         *
 * For the list of contributors see CREDITS.   			         *
 *************************************************************************/

#include "ws/notification/WsnRuntime.h"

ws::notification::WsnRuntime* ws::notification::WsnRuntime::instance_ = 0;

ws::notification::WsnRuntime* ws::notification::WsnRuntime::getRuntime( )
{
	if (instance_ == 0)
	{
		instance_ = new ws::notification::WsnRuntime();
	}
	return instance_; 
}

void ws::notification::WsnRuntime::destroyRuntime( )
{
	if (instance_ != 0)
        {
                delete instance_;
                instance_ = 0;
        }	
}

ws::notification::WsnRuntime::WsnRuntime(  )
{	
	m_topicExprEngine = 0;
}

ws::notification::WsnRuntime::~WsnRuntime(  )
{
}

void ws::notification::WsnRuntime::setTopicExpressionEngine( ws::notification::topics::TopicExpressionEngine* topicExprEngine )
{
	m_topicExprEngine = topicExprEngine;
}

ws::notification::topics::TopicExpressionEngine* ws::notification::WsnRuntime::getTopicExpressionEngine(  )
{
	return m_topicExprEngine;
}

	
std::string ws::notification::WsnRuntime::getVersion(  )
{
	return "1.1";
}

